﻿<?php

//2019-04-28

//URL to call this script
// https://<myDomain>/raincalc.php
// https://<myDomain>/raincalc.php?daypast=4&dayfuture=2&lc=60&wc=50&log=1

// this php script needs unix right 700

// #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #
// #  #  #  #  parameter    #  #  #  #
$stationID="IDEHHHUE1";							// WeatherUnderground station ID of the PWS
$apiKey="sadfaq09q85";		// WeatherUnderground API key
$elevation=123;				// elevation of the PWS
$latitude=51.75086212;		// latitude of the PWS
$longitude=7.6285677;		// longitude of the PWS
$metricUnits="m";			// units to get from wunderground "m" for metric units (C, km/h, mm/sm)
							// if you change to other units , you have to convert the input- and/or output-variables of the evapotranspiration calculation function
$vegetationCoeff=60;		// Integer 10 - 120    div. through 100 and multiplied by the reference evapotranspiration to calibrate the ET for a specific vegetation type (default: 80)
							// 10% (Lowest ET) / 20% / 30% / 40% / 50% / 60% (Warm Grass)  / 70% / 80% (Cool Grass) / 90% / 00% (ETo) / 110% / 120% (Highest ET)
$windHeightCorr=0.75;		// multiplied by windSpeedForecast, Determine the windSpeedForecast at the height of 2 m above ground (while meteo standard = 10m), Conversion factor = 0.75 = 4.87/ln (67.8 (10) - 5.42), 
							// see http://www.fao.org/3/x0490e/x0490e07.htm#wind%20profile%20relationship		
$windSpeedCorr=50;			// percent /100  multiplied by windSpeedForecast. Find out the suitable correction factor by comparing forecast and history values. Wind is a important factor for the evapotranspiration.
							// windSpeedCorr for the location to consider 2 factors:
								// windspeedForecast is not a daily average, but the maximum forecasted wind speed for 10-minute averages (called the sustained wind speed)
								// in sheltered or village locations wind is weakened
$daysInPast=4;				// Integer number of days in the past (witout today ) to observe (min = 0 , max = 6)
$daysInFuture=2;			// Integer number of days in the future(without today ) to observe  (min = 0 , max = 5)
$writeLog="1";				// write process logfile ("0" = no, "1" = yes)
$displayLog="0";			// displayLog=0 -> keine Anzeige des ProcessLog,  displayLog=0 -> Anzeige des ProcessLog

// ------------ adapt parameter ----------------
if (isset($_GET['lC'])) { $vegetationCoeff=$_GET['lC']; }
$vegetationCoeff=$vegetationCoeff / 100;	// Umwandlung in Faktor
if (isset($_GET['wC'])) { $windSpeedCorr=$_GET['wC']; }
$windForecastCorr=$windSpeedCorr / 100 * $windHeightCorr;
if (isset($_GET['daypast'])) { $daysInPast=(int)$_GET['daypast']; }
if (isset($_GET['dayfuture'])) { $daysInFuture=(int)$_GET['dayfuture']; }
if (isset($_GET['log'])) { $displayLog=$_GET['log']; }

// #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #
// #  #  #  #  global variables   #  #  #  #
// ----------------------------

$logProcess=array();		// process log array (short)
$logResult=array();			// result log array
$errorKZ=0;					//Process error
$dayNumber=strftime('%j',time());	// today day of the year number
$julianDay=unixtojd(time()); 		// julian day of today

$obsTimeHistory=array();	// daily obsTime
$julianHistorie=array();	// julian day for the key of obsTimeHistory-array
$dayNumberHistory=array();	// day number in the current year
$qcStatusHistory=array();	// daily qcStatus=Quality control indicator: -1: No quality control check  0: possibly incorrect by our quality control algorithm  1: passed quality control
$precipHistory=array();		// daily precipitation totals from the past mm/sqm
$maxTempHistory=array();	// daily maxTemp the past °C
$minTempHistory=array();	// daily minTemp the past °C
$avgTempHistory=array();		// daily avgTemp totals the past °C
$maxHumidityHistory=array();	// daily max rel. Humidity from the past  %
$minHumidityHistory=array();	// daily min rel. Humidity from the past %
$avgWindHistory=array();		// daily avgWind from the past  in km/h for the height of the PWS (here ~2 m above ground)

$daypartNameForecast=array();				// Today or NULL, Tonight, Tomorrow, Tomorrow night, Saturday, Saturday night,...
$daypartPrecipForecast=array();				// precipitation forecast for daypart
$daypartPrecipChanceForecast=array();		// precipitation chance forecast for daypart (chance <40% will be set to 0)
$daypartMeanPrecipForecast=array();			// precipitation forecast weighted by chance for daypart
$daypartRelativeHumidityForecast=array();	// mean humidity forcast for daypart
$daypartWindSpeedForecast=array();			// windspeed forcast for daypart: maximum forecasted wind speed, for 10-minute averages called the sustained wind speed)

$dayNameForecast=array();			// Friday, Saturday, ...
$maxTempForecast=array();			// 22, °C, Daily maximum temperature, Integer, (null ab 15:00 Uhr)
$minTempForecast=array();			// 20, °C,  (Daily minimum temperature, Integer)
$qpfForecast=array();				// 1.23 mm, qpf for 24h day (max., precipitation chance not taken ito account)
$PrecipForecast=array();			// 0.04 mean of the chance weighted precipitation forecasts during 24 hour period (calculated from dayparts) mm/sqm
									// forecasted measurable precipitation (liquid or liquid equivalent) during 12 hour period} * precriptionChance   ,  thereby applies:  if precriptionChance < 50% then precriptionChance = 0
$minHumidityForecast=array();		// 0 to 100 percentage,  minimum of the relative humidity of the air for both 12 hour periods 
$maxHumidityForecast=array();		// 0 to 100 percentage,  maximum of the relative humidity of the air for both 12 hour periods
									// which is defined as the ratio of the amount of water vapor in the air to the amount of vapor required to bring the air to saturation at a constant temperature.
$avgWindForecast=array();			// km/h, integer, mean of the wind speed for the day (after some conversions of the wunderground raw data, see $windCoefficient, $windHeightCorr


// #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #
// #  #  #  #  global functions   #  #  #  #

function url_get_contents($url) {
	global $logProcess;
    $connSuccess=0;
	if (function_exists('curl_exec')){
        $conn = curl_init($url);
        curl_setopt($conn, CURLOPT_SSL_VERIFYPEER, true);
        curl_setopt($conn, CURLOPT_FRESH_CONNECT,  true);
        curl_setopt($conn, CURLOPT_RETURNTRANSFER, 1);
        $url_get_contents_data = (curl_exec($conn));
		if(curl_errno($conn)) {
			$logProcess[]="curl-Error: " . curl_error($conn);
		} else { 
			$connSuccess=1;
			$logProcess[]="curl-Success";
		}
        curl_close($conn);
    }
	if($connSuccess == 0 and function_exists('file_get_contents')) {
		if (!$url_get_contents_data = file_get_contents($url)) {
			$logProcess[]="file_get_contents-Error";
		} else {
			$connSuccess=1;
			$logProcess[]="file_get_contents-Success";
		}
    }
	if($connSuccess == 0 and function_exists('fopen') and function_exists('stream_get_contents')){
        $handle = fopen ($url, "r");
        if (!$url_get_contents_data = stream_get_contents($handle)) {
			$logProcess[]="fopen-Error";
		} else {
			$connSuccess=1;
			$logProcess[]="fopen-Success";
		}
	}
	if($connSuccess == 0) {
		$url_get_contents_data=false;
	}
	return $url_get_contents_data;
} 

function errOut($errMsg) {
	global $errorKZ, $logProcess;
    $logProcess[]="Fehler: " . $errMsg;
	++$errorKZ;
}

function calcSaturationVaporPressure($temp) {
  return 0.6108 * exp((17.27 * $temp) / ($temp + 237.3));
}

function calcSlopeOfSaturationVaporPressureCurve($meanTemp) {
  $meanSaturationVaporPressure = calcSaturationVaporPressure($meanTemp);
  return 4098 * $meanSaturationVaporPressure / pow($meanTemp + 237.3, 2);
}

function calcAtmosphericPressure() {
	global $elevation;
	return 101.3 * pow((293 - 0.0065 * $elevation) / 293, 5.26);
}

function calcPsychrometricConstant($atmospericPressure) {
  return 0.000665 * $atmospericPressure;
}

function calcDeltaTerm($slopeOfSaturationVaporPressureCurve, $psychrometricConstant , $avgWind) {
  return $slopeOfSaturationVaporPressureCurve / ($slopeOfSaturationVaporPressureCurve + $psychrometricConstant * (1 + 0.34 * $avgWind));
}

function calcPsiTerm($slopeOfSaturationVaporPressureCurve, $psychrometricConstant , $avgWind) {
  return $psychrometricConstant / ($slopeOfSaturationVaporPressureCurve + $psychrometricConstant * (1 + 0.34 * $avgWind));
}

function calcTemperatureTerm($meanTemp, $avgWind) {
  return 900 / ($meanTemp + 273) * $avgWind;
}

function calcMeanSaturationVaporPressure($minTemp, $maxTemp) {
  $minTempSatVapPressure  = calcSaturationVaporPressure($minTemp);
  $maxTempSatVapPressure = calcSaturationVaporPressure($maxTemp);
  return ($minTempSatVapPressure + $maxTempSatVapPressure) / 2;
}

function calcActualVaporPressure($minTemp, $maxTemp, $minHumidity, $maxHumidity) {
  $minTempSatVapPressure  = calcSaturationVaporPressure($minTemp);
  $maxTempSatVapPressure = calcSaturationVaporPressure($maxTemp);
  return (($minTempSatVapPressure * $maxHumidity / 100) + ($maxTempSatVapPressure * $minHumidity / 100)) / 2;
}

function calcInverseRelativeDistanceToSun($julianDay) {
  return 1 + 0.033 * cos(2 * pi() * $julianDay / 365);
}

function calcSolarDeclination($julianDay) {
  return 0.409 * sin(2 * pi() * $julianDay / 365 - 1.39);
}

function calcSunsetHourAngle($solarDeclination) {
	global $latitude ;
	return acos(-tan($latitude) * tan($solarDeclination));
}

function calcExtraterrestrialRadiation($inverseRelativeDistanceToSun, $sunsetHourAngle, $solarDeclination) {
	global $latitude;
  return 37.6 * $inverseRelativeDistanceToSun * (($sunsetHourAngle * sin($latitude) * sin($solarDeclination)) + (cos($latitude) * cos($solarDeclination) * sin($sunsetHourAngle)));
}

function calcClearSkySolarRadiation($extraterrestrialRadiation) {
	global $elevation;
  return (0.75 + 0.00002 * $elevation) * $extraterrestrialRadiation;
}

function calcSolarRadiation($minTemp, $maxTemp, $extraterrestrialRadiation) {
  return 0.177 * sqrt($maxTemp - $minTemp) * $extraterrestrialRadiation;
}

function calcNetShortwaveRadiation($solarRadiation) {
  return (1 - 0.23) * $solarRadiation;
}

function calcNetLongwaveRadiation($minTemp, $maxTemp, $actualVaporPressure, $solarRadiation, $clearSkySolarRadiation) {
  return 4.903 * pow(10, -9) * (pow($maxTemp + 273.16, 4) + pow($minTemp + 273.16, 4)) / 2 * (0.34 - 0.14 * sqrt($actualVaporPressure)) * (1.35 * $solarRadiation / $clearSkySolarRadiation - 0.35);
}

function calcNetRadiation($netShortwaveRadiation, $netLongwaveRadiation) {
  return 0.408 * ($netShortwaveRadiation - $netLongwaveRadiation);
}

function calcETRadiationTerm($deltaTerm, $netRadiation) {
  return $deltaTerm * $netRadiation;
}

function calcETWindTerm($psiTerm, $temperatureTerm, $meanSaturationVaporPressure, $actualVaporPressure) {
  return $psiTerm * $temperatureTerm * ($meanSaturationVaporPressure - $actualVaporPressure);
}

function calcReferenceEvapotranspiration($minTemp, $maxTemp, $avgTemp, $minHumidity, $maxHumidity, $avgWind, $julianDay) {
	global $metricUnits;
	$avgWind=$avgWind * 0.2778;		//Convert from km/h to m/s
	$slopeOfSaturationVaporPressureCurve = calcSlopeOfSaturationVaporPressureCurve($avgTemp);
	$atmosphericPressure = calcAtmosphericPressure();
	$psychrometricConstant = calcPsychrometricConstant($atmosphericPressure);
	$deltaTerm = calcDeltaTerm($slopeOfSaturationVaporPressureCurve, $psychrometricConstant, $avgWind);
	$psiTerm = calcPsiTerm($slopeOfSaturationVaporPressureCurve, $psychrometricConstant, $avgWind);
	$temperatureTerm = calcTemperatureTerm($avgTemp, $avgWind);
	$meanSaturationVaporPressure = calcMeanSaturationVaporPressure($minTemp, $maxTemp);
	$actualVaporPressure = calcActualVaporPressure($minTemp, $maxTemp, $minHumidity, $maxHumidity);
	$inverseRelativeDistanceToSun = calcInverseRelativeDistanceToSun($julianDay);
	$solarDeclination = calcSolarDeclination($julianDay);
	$sunsetHourAngle = calcSunsetHourAngle($solarDeclination);
	$extraterrestrialRadiation = calcExtraterrestrialRadiation($inverseRelativeDistanceToSun, $sunsetHourAngle, $solarDeclination);
	$clearSkySolarRadiation = calcClearSkySolarRadiation($extraterrestrialRadiation);
	$solarRadiation = calcSolarRadiation($minTemp, $maxTemp, $extraterrestrialRadiation);
	$netShortwaveRadiation = calcNetShortwaveRadiation($solarRadiation);
	$netLongwaveRadiation = calcNetLongwaveRadiation($minTemp, $maxTemp, $actualVaporPressure, $solarRadiation, $clearSkySolarRadiation);
	$netRadiation = calcNetRadiation($netShortwaveRadiation, $netLongwaveRadiation);
	$etRadiationTerm = calcETRadiationTerm($deltaTerm, $netRadiation);
	$etWindTerm = calcETWindTerm($psiTerm, $temperatureTerm, $meanSaturationVaporPressure, $actualVaporPressure);
	$referenceEvapotranspiration = $etRadiationTerm + $etWindTerm;
	return array($referenceEvapotranspiration, $etRadiationTerm, $etWindTerm);
}


// #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #
// #  #  #  #  main procedure   #  #  #  #

$logProcess[]="<br># # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #";
$logProcess[]="QString: " . $_SERVER['QUERY_STRING'];
$logProcess[]="Start: " . date("Y-m-d_G:i:s") . " dayNumer: " . $dayNumber . " julianDay: " . $julianDay;

$json_hist = "https://api.weather.com/v2/pws/dailysummary/7day?stationId=" . $stationID. "&format=json&units=" . $metricUnits . "&apiKey=" . $apiKey;
$json=url_get_contents($json_hist);
$data=json_decode($json);	
if (json_last_error() != JSON_ERROR_NONE) { errOut(json_last_error); }
$logProcess[]="History returned: " . date("Y-m-d_G:i:s");

if ($data->summaries[0]->stationID) {
	if (print_r($data->summaries[0]->stationID,true) != $stationID) { errOut($stationID); }
} else { errOut($stationID);}

$i=0;
while($i <= (count($data->summaries) - 1)) {
	global $qcStatusHistory, $obsTimeHistory, $dayNumberHistory, $julianHistorie, $precipHistory, $maxTempHistory, $minTempHistory, $avgTempHistory, $maxHumidityHistory, $minHumidityHistory, $avgWindHistory;

	if (isset($data->summaries[$i]->obsTimeLocal)) { $obsTimeHistory[$i]=$data->summaries[$i]->obsTimeLocal; } else { errOut('obsTimeHistory' . $i); }
	if (isset($data->summaries[$i]->epoch)) {
		$julianHistorie[$i]=unixtojd($data->summaries[$i]->epoch);
		$dayNumberHistory[$i]=strftime('%j',$data->summaries[$i]->epoch);
	} else { errOut('epochHistory' . $i); }
	if (isset($data->summaries[$i]->qcStatus)) { $qcStatusHistory[$i]=$data->summaries[$i]->qcStatus; } else { errOut('qcStatusHistory' . $i); }
	if (isset($data->summaries[$i]->metric->precipTotal)) { $precipHistory[$i]=$data->summaries[$i]->metric->precipTotal; } else { errOut('precipHistory' . $i); }
	if (isset($data->summaries[$i]->metric->tempHigh)) { $maxTempHistory[$i]=$data->summaries[$i]->metric->tempHigh; } else { errOut('maxTempHistory' . $i); }
	if (isset($data->summaries[$i]->metric->tempAvg)) { $avgTempHistory[$i]=$data->summaries[$i]->metric->tempAvg; } else { errOut('avgTempHistory' . $i); }
	if (isset($data->summaries[$i]->metric->tempLow)) { $minTempHistory[$i]=$data->summaries[$i]->metric->tempLow; } else { errOut('minTempHistory' . $i); }
	if (isset($data->summaries[$i]->humidityHigh)) { $maxHumidityHistory[$i]=$data->summaries[$i]->humidityHigh; } else { errOut('maxHumidityHistory' . $i); }
	if (isset($data->summaries[$i]->humidityLow)) { $minHumidityHistory[$i]=$data->summaries[$i]->humidityLow; } else { errOut('minHumidityHistory' . $i); }
	if (isset($data->summaries[$i]->metric->windspeedAvg)) { $avgWindHistory[$i]=$data->summaries[$i]->metric->windspeedAvg; } else { errOut('avgWindHistory' . $i); }
	$i++;
}
unset($json_hist, $json, $data, $item );

$json_forcast = "https://api.weather.com/v3/wx/forecast/daily/5day?geocode=" . $latitude . "," . $longitude . "&language=en-US&format=json&units=" . $metricUnits . "&apiKey=" . $apiKey;
$json=url_get_contents($json_forcast);
$data=json_decode($json);
if (json_last_error() != JSON_ERROR_NONE) { errOut(json_last_error); }
$logProcess[]="Forecast returned: " . date("Y-m-d_G:i:s");

if (isset($data->dayOfWeek)) {$dayNameForecast=$data->dayOfWeek; } else { errOut('dayNameForecast'); }
if (isset($data->temperatureMin)) {$minTempForecast=$data->temperatureMin; } else { errOut('minTempForecast'); }
if (isset($data->temperatureMax)) {$maxTempForecast=$data->temperatureMax; } else { errOut('maxTempForecast'); }
if (isset($data->qpf)) {$qpfForecast=$data->qpf; } else { errOut('qpfForecast'); }
if ( is_null($maxTempForecast[0]) ) { $maxTempForecast[0]="x"; }
if (isset($data->daypart[0]->daypartName)) {$daypartNameForecast=$data->daypart[0]->daypartName; } else { errOut('daypartNameForecast'); }
if (isset($data->daypart[0]->qpf)) {$daypartPrecipForecast=$data->daypart[0]->qpf; } else { errOut('daypartPrecipForecast'); }
if (isset($data->daypart[0]->precipChance)) {$daypartPrecipChanceForecast=$data->daypart[0]->precipChance; } else { errOut('daypartPrecipChanceForecast'); }
if (isset($data->daypart[0]->relativeHumidity)) {$daypartRelativeHumidityForecast=$data->daypart[0]->relativeHumidity; } else { errOut('daypartRelativeHumidityForecast'); }
if (isset($data->daypart[0]->windSpeed)) {$daypartWindSpeedForecast=$data->daypart[0]->windSpeed; } else { errOut('daypartWindSpeedForecast'); }

$i=0;
while($i <= 11) {
	global $daypartPrecipChanceForecast, $daypartWindSpeedForecast, $windForecastCorr;
	if (is_null($daypartPrecipChanceForecast[$i]) or $daypartPrecipChanceForecast[$i] < 40) { $daypartPrecipChanceForecast[$i]=0; }
	$daypartPrecipChanceForecast[$i]=round( ($daypartPrecipChanceForecast[$i] / 100) , 1);
	$daypartWindSpeedForecast[$i]=round( ($daypartWindSpeedForecast[$i] * $windForecastCorr), 0); 	
	$i++;
}

$i=0;
$j=0;
while($i <= 11) {
	global $PrecipForecast, $qpfForecast, $daypartPrecipForecast, $daypartPrecipChanceForecast, $minHumidityForecast, $maxHumidityForecast, $daypartRelativeHumidityForecast, $avgWindForecast, $daypartWindSpeedForecast;
	if ($i < 2) {
		$precipForecast[$j]="x";
		$minHumidityForecast[$j]="x";
		$maxHumidityForecast[$j]="x";
		$avgWindForecast[$j]="x";
	}  else {
		$precipForecast[$j]=round( max( ($qpfForecast[$j] * (7 * $daypartPrecipChanceForecast[$i-1] + 12 * $daypartPrecipChanceForecast[$i] + 5 * $daypartPrecipChanceForecast[$i+1]) / 24) , ($daypartPrecipForecast[$i]	* $daypartPrecipChanceForecast[$i+1] + ($qpfForecast[$j] - $daypartPrecipForecast[$i]) * $daypartPrecipChanceForecast[$i+1]) ) , 1);
		$minHumidityForecast[$j] = min ($daypartRelativeHumidityForecast[$i], $daypartRelativeHumidityForecast[$i+1] );
		$maxHumidityForecast[$j] = max ($daypartRelativeHumidityForecast[$i], $daypartRelativeHumidityForecast[$i+1] );
		$avgWindForecast[$j]= round( (($daypartWindSpeedForecast[$i] + $daypartWindSpeedForecast[$i+1]) / 2),0 );
	}
	$j++;
	$i = $i + 2;
}
unset($json_hist, $json, $data );

$res=array();
$i=0;
$j=0;
while($i <= $daysInPast) {
	global $logProcess, $julianHistorie, $daysInPast;
	$res['Period'][$i]=0;
	$res['Rain'][$i]=0;
	$res['minTemp'][$i]=0;
	$res['maxTemp'][$i]=0;
	$res['avgTemp'][$i]=0;
	$res['minHumidity'][$i]=0;
	$res['maxHumidity'][$i]=0;
	$res['avgWind'][$i]=0;
	$res['dayNumber'][$i]=0;
	while($j <= (count($julianHistorie) - 1)) {
		global $logProcess, $daysInPast, $julianDay, $julianHistorie, $precipHistory, $minTempHistory, $maxTempHistory, $minHumidityHistory, $maxHumidityHistory, $avgWindHistory, $dayNumberHistory;
		$p=$julianHistorie[$j]-$julianDay;
			if ($i == $daysInPast + $p) {
				$res['Period'][$i]=$julianHistorie[$j]-$julianDay;
				$res['dayNumber'][$i]=$dayNumberHistory[$j];
				$res['Rain'][$i]=$precipHistory[$j];
				$res['minTemp'][$i]=$minTempHistory[$j];
				$res['avgTemp'][$i]=$avgTempHistory[$j];
				$res['maxTemp'][$i]=$maxTempHistory[$j];
				$res['minHumidity'][$i]=$minHumidityHistory[$j];
				$res['maxHumidity'][$i]=$maxHumidityHistory[$j];
				$res['avgWind'][$i]=$avgWindHistory[$j];
				$j++;
				break;
			}
		$j++;
	}
	$i++;
}

$j=1;
while($j <= ($daysInFuture)) {
	global $logProcess,$res, $dayNumber, $daysInPast, $precipForecast, $minTempForecast, $maxTempForecast, $minHumidityForecast, $maxHumidityForecast, $avgWindForecast;
	$i=$j + $daysInPast;	// tomorrow column
	$res['Period'][$i]=$j;
	$res['Rain'][$i]=$precipForecast[$j];
	$res['minTemp'][$i]=$minTempForecast[$j];
	$res['maxTemp'][$i]=$maxTempForecast[$j];
	$res['avgTemp'][$i]=round ( ($maxTempForecast[$j] + $minTempForecast[$j]) / 2, 0);
	$res['minHumidity'][$i]=$minHumidityForecast[$j];
	$res['maxHumidity'][$i]=$maxHumidityForecast[$j];
	$res['avgWind'][$i]=$avgWindForecast[$j]; 	
	$res['dayNumber'][$i]=$dayNumber + $j;
	$j++;
}

$t=date('G')+0;
$i=$daysInPast;
$res['minTemp'][$i] = min( (int)$res['minTemp'][$i], (int)$minTempForecast[$i] );
if ($t<3) {
	$res['Rain'][$i] = round( max( $res['Rain'][$i] , ($qpfForecast[0] * ($daypartPrecipChanceForecast[1] + $daypartPrecipChanceForecast[2]) / 2)) , 1);
	$res['minHumidity'][$i] = min( (int)$res['minHumidity'][$i], (int)$daypartRelativeHumidityForecast[1] );
	$res['maxHumidity'][$i] = max( (int)$res['maxHumidity'][$i], (int)$daypartRelativeHumidityForecast[1] );
	$res['avgWind'][$i] = round( ($daypartWindSpeedForecast[2] + $daypartWindSpeedForecast[3] / 2) , 0 ) ;
} elseif ($t<15) {
	$res['Rain'][$i] = round( max( $res['Rain'][$i] , ($daypartPrecipForecast[0] * $daypartPrecipChanceForecast[0]) ,  (($qpfForecast[0]-$daypartPrecipForecast[0]) * $daypartPrecipChanceForecast[1] )), 1 );
	$res['minHumidity'][$i] = min( (int)$res['minHumidity'][$i], (int)$daypartRelativeHumidityForecast[0], (int)$daypartRelativeHumidityForecast[1] );
	$res['maxHumidity'][$i] = max( (int)$res['maxHumidity'][$i], (int)$daypartRelativeHumidityForecast[0], (int)$daypartRelativeHumidityForecast[1] );	
} else {
	$res['Rain'][$i] = round( max($res['Rain'][$i] , ($qpfForecast[0]-$daypartPrecipForecast[1])) , 1);
	$res['minHumidity'][$i] = min( (int)$res['minHumidity'][$i], (int)$daypartRelativeHumidityForecast[1] );
	$res['maxHumidity'][$i] = max( (int)$res['maxHumidity'][$i], (int)$daypartRelativeHumidityForecast[1] );		
	$res['avgWind'][$i] = round( (($t * $res['avgWind'][$i] + (24-$t) * $daypartWindSpeedForecast[1]) / 24),0 ) ;	
}

$sum=array();
$sum['PlantNeeds']=0;
$sum['Rain']=0;
$sum['WaterNeeds']=0;
$i=0;
while ($i <= (count($res['dayNumber'])-1) ) {
	global  $vegetationCoeff, $res, $sum, $logProcess;
	$resultEvpo=array();
	$resultEvpo=calcReferenceEvapotranspiration( $res['minTemp'][$i], $res['maxTemp'][$i], $res['avgTemp'][$i], $res['minHumidity'][$i], $res['maxHumidity'][$i], $res['avgWind'][$i], $res['dayNumber'][$i] );
	
	$res['PlantNeeds'][$i]=round( ($vegetationCoeff * $resultEvpo[0]), 1);
	$res['etRadiationTerm'][$i]=round( ($vegetationCoeff * $resultEvpo[1]), 1);
	$res['etWindTerm'][$i]=round( ($vegetationCoeff * $resultEvpo[2]), 1);
	$res['Rain'][$i]=number_format( $res['Rain'][$i],1 );
	$sum['Rain'] += $res['Rain'][$i];
	$sum['PlantNeeds'] += number_format($res['PlantNeeds'][$i],1 );
	$res['WaterNeeds'][$i]=$res['PlantNeeds'][$i] - $res['Rain'][$i];
	$sum['WaterNeeds'] += $res['WaterNeeds'][$i];
	$i++;
}
$switchWater="RunWater";
if ($sum['WaterNeeds'] < 0) { $switchWater="StopWater"; }

$jArr=array();
$jArr['Period']="Day " . implode("|",$res['Period']);
$jPeriod=explode("0", $jArr['Period']);
$jArr['Period']= $jPeriod[0] . "0" . str_replace("|", "|+", $jPeriod[1]);
$jArr['Rain']=implode("|",$res['Rain']);
$jArr['PlantNeeds']=implode("|",$res['PlantNeeds']);
$jArr['WaterNeeds']=implode("|",$res['WaterNeeds']);
$jArr['SumRain']="SumRain = " . $sum['Rain'];
$jArr['SumPlantNeeds']="SumPlantNeeds = " . $sum['PlantNeeds'];
$jArr['SumWaterNeeds']="SumWaterNeeds = " . $sum['WaterNeeds'];
$jArr['SwitchWater']="Action: " . $switchWater;
$logProcess[]="<pre>" . print_r($jArr,true) . "</pre>";
$jsonEnc=json_encode($jArr);
echo $jsonEnc;

// #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #
// #  #  #  #  end and log   #  #  #  #

$logProcess[]="wunderground data errors: " . $errorKZ;
$logProcess[]="Ende: " . date("Y-m-d H:i:s");
$logProcess[]="# # # # # # # # # # # #";

// - - - - - - - display process log - - - - - -
if ($displayLog == '1') { 
	echo "<br /><br /># # # # # test modus, displayLog=1 # # # # # # #";
	echo "<br> * JSON response see above*";
	echo implode("<br />",$logProcess);
}

?>

